/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.services.SubstanceAdministration.testcases.customizedscp;
import cdac.medinfo.sdk.dcm30_04.baselibs.DataSet;
import cdac.medinfo.sdk.dcm30_04.baselibs.DicomV3Factory;
import cdac.medinfo.sdk.dcm30_04.baselibs.ImplicitDE;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataTypeSQ;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IItem;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.enums.EnumLoggingLevel;
import cdac.medinfo.sdk.dcm30_04.enums.EnumPDUType;
import cdac.medinfo.sdk.dcm30_04.enums.EnumSOPClassUIDs;
import cdac.medinfo.sdk.dcm30_04.services.association.AReleaseRQorRP;
import cdac.medinfo.sdk.dcm30_04.services.association.AssociateRQ;
import cdac.medinfo.sdk.dcm30_04.services.association.AssociationNegotiator;
import cdac.medinfo.sdk.dcm30_04.services.association.DefaultAssociation;
import cdac.medinfo.sdk.dcm30_04.services.association.IDIMSEAssociation;
import cdac.medinfo.sdk.dcm30_04.services.cfind.scp.CFindSCP;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumDataSource;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumServiceType;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.DIMSEResponse;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.IDataSource;
import cdac.medinfo.sdk.dcm30_04.services.scp.commons.ClientSession;
import cdac.medinfo.sdk.dcm30_04.services.scp.commons.ProcessHandler;
import cdac.medinfo.sdk.dcm30_04.services.scp.commons.SCPSession;
import cdac.medinfo.sdk.dcm30_04.services.substanceadministration.sourceimpl.SubstanceAdministrationDataSourceImpl;
import cdac.medinfo.sdk.dcm30_04.services.substanceadministration.sourceimpl.SubstanceAdministration_StoreAgent;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;

/**
 * This is the customized implementation of the test code for SubstanceAdministrationInfoQry Services.
 * This sample codes is to show how user can define its own implementation for handling connection, association and service request.
 * In this sample test code all the required methods of IProcessHandler are implemented (onConnect(), onAssociateReceive() and onServiceRequest()) 
 * and their definition is provided here. User can define these methods according to his need.
 * This test code uses C-Find SCP to process the SubstanceAdministrationInfoQry request. Once the Data Source Implementation for 
 * SubstanceAdministrationInfoQry is set on C-Find SCP it is capable of handling C-Find request.
 * To create DB for Substance Administration Information  refer SQL Script SubstanceAdmininstrationDB.sql provided in install.
 */
public class SubstanceAdministrationInfoQry_CFind_SCP_Cust_ProcHandler
{
	public static void main(String[] args) 
	{
		try
		{
			DicomConfig objDicomConfig = DicomConfig.createInstance();
			//enable logging,specify the path of the directory where log files are created.
			//User can specify any directory in place of 'c:\DCM_Logs'.
			//If no directory is defined by user to create logs then it is created in User Temp DIR.
			objDicomConfig.enableLogging(EnumLoggingLevel.INFO, "C:\\DCM_Logs");
			/*
			 * Populating Database with data set on which find request will be processed.
			 */
			SubstanceAdministrationInfoQry_CFind_SCP_Cust_ProcHandler objTest = new SubstanceAdministrationInfoQry_CFind_SCP_Cust_ProcHandler();
			IDataSet objIDataSet = objTest.populateDataset();
			objTest.storeInstanceInfo(objIDataSet);

			/*
			 * Create DataSourceImpl with ConnectionString and driver String.
			 * DataSourceImpl is default implementation of library which uses JavaDB to 
			 * find Data Elements.The user has to start javaDB server before connection
			 * if Client Server model in java DB is used.
			 * This DataSource should be set in CFind SCP.
			 * User can also provide its own implementation of IDataSource interface
			 * to find the attributes.
			 */
			String dataBasePath = "D:/SDKDatabase/SubstanceAdmininstrationDB.sql";
			String ConnectionString = "jdbc:derby://localhost:5050/" + dataBasePath;
			String driverString = "org.apache.derby.jdbc.ClientDriver";

			IDataSource obSubstanceAdministrationInfoQryDataSource = new SubstanceAdministrationDataSourceImpl(ConnectionString,driverString);

			/*
			 * Creates TestCStoreSCP.
			 */
			SubstanceAdministrationInfoQry_CFind_SCPHandler scp = new SubstanceAdministrationInfoQry_CFind_SCPHandler();
			scp.addDataSource(EnumDataSource.SUBSTANCE_ADMINISTRATION_INFO_QRY,obSubstanceAdministrationInfoQryDataSource);

			/*
			 * Created SCP session and set Default association and Process Handler on it.
			 */
			SCPSession session = new SCPSession();

			/*
			 * Initializes the service types and sets it on SCP Session
			 * EnumService Type configures SCP Session to load corresponding association context and start
			 * corresponding DIMSE Services.
			 */
			EnumServiceType []arrenumServiceType = new EnumServiceType[1];
			arrenumServiceType[0] = EnumServiceType.CFIND_SUBSTANCEADMINISTRATION;
			session.selectServices(arrenumServiceType);

			//Set Process Handler as the SCP TestCode
			session.setIProcessHandler(scp);
			
			/*
			 * Setting time out as 5000 milli second. It will wait 5000 mili seconds for read and write operation.
			 * If in the time specified (5000 ms) read or write operation is not performed then 
			 * session is time out.
			 */ 
			//session.setTimeOut(5000);

			//Start the Session
			session.start("SDK",9000);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	/*
	 * This function populates the data set. SubstanceAdministrationInfoQry service query on instance populated.
	 */
	public IDataSet populateDataset()
	{
		IDataSet objIDataSet = new DataSet();
		IDictionaryReader objDictionaryReader = objIDataSet.getDictionaryReader();
		ITransferSyntax objTS = objIDataSet.getTransferSyntax();
		
		objIDataSet.addDataElement(getDataElement(0x0000,0x0002, EnumSOPClassUIDs.DCM_PRODUCT_CHARACTERISTICS_QUERY_SOP_CLASS.getValue(), objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0000,0x0120,  (short)10, objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0000,0x0800, (short)12, objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0010, "LEELA ", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0020, "33221", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0021, "Dr. Bradd Lawrence", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0030, "19790421", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0010,0x0040, "F", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0038,0x0010, "9182", objDictionaryReader));

		IDataTypeSQ objConceptNameCodeSQ = getSQ(0x0038,0x0014,objTS);
		IItem objConceptNameCodeItem = objConceptNameCodeSQ.getNewItem();		
		objConceptNameCodeItem.addDataElement(getDataElement(0x0040,0x0031, "Georgia Medical Center", objDictionaryReader));		
		objConceptNameCodeSQ.addItem(objConceptNameCodeItem);
		objIDataSet.addDataElement(getDataElement(0x0038,0x0014,objConceptNameCodeSQ.getValue(), objDictionaryReader));
		
		objIDataSet.addDataElement(getDataElement(0x0044,0x0001, "0011010", objDictionaryReader));

		IDataTypeSQ objContentTemplateSQ = getSQ(0x0054,0x0302,objTS);
		IItem objContentTemplateItem = objContentTemplateSQ.getNewItem();
		objContentTemplateItem.addDataElement(getDataElement(0x0008,0x0100, "T-28600", objDictionaryReader));
		objContentTemplateItem.addDataElement(getDataElement(0x0008,0x0102, "SRT", objDictionaryReader));
		objContentTemplateItem.addDataElement(getDataElement(0x0008,0x0104, "Slide", objDictionaryReader));
		objContentTemplateSQ.addItem(objContentTemplateItem);
		objIDataSet.addDataElement(getDataElement(0x0054,0x0302,objContentTemplateSQ.getValue(), objDictionaryReader));
		
		objIDataSet.addDataElement(getDataElement(0x0044,0x0002, "WARNING", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0044,0x0003, "Information Required", objDictionaryReader));
		objIDataSet.addDataElement(getDataElement(0x0044,0x0004, "20021114124623", objDictionaryReader));

		return objIDataSet;
	}

	/*
	 * This function create the data element from the information provided.
	 */
	private IDataElement getDataElement(int GroupNo,int ElementNo,Object objVal,IDictionaryReader objDictionaryReader)
	{
		IDataElement objIDataElement = new ImplicitDE(GroupNo, ElementNo,objVal,objDictionaryReader);
		return objIDataElement;
	}

	/*
	 * This function gets the sequence belonging to group no and element number specified.
	 */
	private IDataTypeSQ getSQ(int GroupNo,int ElementNo , ITransferSyntax objTS)
	{
		return DicomV3Factory.createInstance().createSequence(GroupNo, ElementNo, objTS);
	}


	/*
	 * This function stores the dataset instance to database.
	 */
	public void storeInstanceInfo(IDataSet objIDataSet)
	{
		try
		{
			/*
			 * Create DataBase and store dataset to database using SubstanceAdministrationStoreAgent.
			 */
			String dataBasePath = "D:/SDKDatabase/SubstanceAdmininstrationDB.sql";
			String ConnectionString = "jdbc:derby://localhost:5050/" + dataBasePath;
			String driverString = "org.apache.derby.jdbc.ClientDriver";
			SubstanceAdministration_StoreAgent  objSubstanceAdministrationStoreAgent = new SubstanceAdministration_StoreAgent(ConnectionString, driverString);
			objSubstanceAdministrationStoreAgent.storeInstanceInfo(objIDataSet);
		}
		catch(Exception e)
		{
			System.out.println("Exception occured while insertion");
			e.printStackTrace();
		}
	}
}

/**
 * This class is implemented to test the SubstanceAdministrationInfoQry SCP.
 * In order to run the following class , please refer to this link($Link) to create the environment.
 * To implement an SCP of a particular we need to do the following things :
 * To create SCP user should either has to implement class IProcessHandler (which is an interface ) or extends Process handler.
 * If test code implements process handler then user has to provide implementation of the methods declared in the interface.
 * Otherwise he can extend the process handler which contains the default implementation for processing of association and service request.
 * Create the SCPSession object which maintains the session of the SCP. 
 * Set the default association and Process handler(reference of test code) in SCPSession.
 * Its "start" method starts the SCP server.
 * When an SCU connects to the SubstanceAdministrationInfoQry SCP then when the connection is accepted client session is created for that SCU.
 * When SCU connects to the SubstanceAdministrationInfoQry SCP the call back on onConnect of ProcessHandler is made. Now user can get the connection parameters
 * from client session and can decide whether to accept the connection or not. To accept the connection user has to
 * pass true to acceptConnection function in ClientSession class.
 * After the connection is established the next request expected to arrive at SCP is Association request.
 * When Association request arrives, callback is made to onAssociateReceive method of ProcessHandler.
 * User now can negotiate Association request with the default association and creates AssociateAC or Reject.
 * The library provides AssociationNegotiator Class to negotiate and create appropriate response.
 * When C-Find request for SubstanceAdministrationInfoQry arrives the call back is made to onServiceRequest method of ProcessHandler.
 * The user can get the C-Find Request from current ClientSession object passed in onServiceRequest method, processes it
 * and creates C-Find-RSP. SDK provides processRequest method in C-FindSCP to process the request and generates response.
 * The SCP search for the matches in javaDB and sends pending response for each match found.
 * Then success response is send to the SCU.
 * The C-Find SCP can handle multiple request simultaneously.
 * After this, when A-Release-RQ arrives , Create Release response and send it to the SCU.
 * Whenever the SCU goes down its client session is also closed or SCP can close the client session 
 * by calling close method of client session.
 */
class SubstanceAdministrationInfoQry_CFind_SCPHandler extends ProcessHandler
{
	/**
	 * This method notifies when a new client connection is requested. A decision is to be made whether to
	 * accept or reject the connection.  
	 * @param objClientSession  object of client session.
	 */
	public void onConnect(ClientSession objClientSession)
	{
		objClientSession.acceptConnection(true);
	}

	/**
	 * This method notifies when Association Request, Associate Release Request or Abort is received from one of the 
	 * SCUs. 
	 * If Association Request is received,
	 * 		Create Association Negotiator which negotiates the request with the existing default association and
	 * 		creates an AgreedAssociation which contains the negotiated association values. AssociationNegotiator
	 * 		returns the Association Response as AssociateAC when request is accepted or returns AssociateRJ is 
	 * 		none of the values in Association Request are acceptable.
	 * 	If Associate Release Request is received,
	 * 		Create a Associate Release Response and send the response to the SCU using the respective ClientSession.
	 *  If Abort is received,
	 *  	An Abort response must be generated and sent using ClientSession
	 *@param objClientSession  object of client session.
	 */
	public void onAssociateReceive(ClientSession objClientSession) 
	{
		//Get Association RQ
		IDIMSEAssociation objIDIMSEAssociation = objClientSession.getDIMSEAssociation();
		EnumPDUType enumPDUType = objIDIMSEAssociation.getPDUType();
		IDIMSEAssociation objAssociationRSP = null;

		//For Association Request negotiate with Default Association and generate Response
		switch(enumPDUType)
		{
		case ASSOCIATE_RQ :
		{
			System.out.println("Association Request Received");

			AssociateRQ objAssociateRQ = (AssociateRQ)objIDIMSEAssociation;

			//get the default association from Client Session.
			DefaultAssociation objDefaultAssociation = objClientSession.getDefaultAssociation();

			//Negotiate and get Response
			AssociationNegotiator objAssNegotiator = new AssociationNegotiator();
			objAssociationRSP = objAssNegotiator.negotiate(objDefaultAssociation, objAssociateRQ);

			//set agreed association in client Session.
			objClientSession.setAgreedAssociation(objAssNegotiator.getAgreedAssociation());

			//Send Response
			objClientSession.sendAssociationMessage(objAssociationRSP);
			break;
		}
		case RELEASE_RQ :
		{
			System.out.println("Release Request Received");

			//Create Release Response.
			objAssociationRSP = new AReleaseRQorRP(EnumPDUType.RELEASE_RP);

			//Send Response
			objClientSession.sendAssociationMessage(objAssociationRSP);
			System.out.println("Release Response sent");

			//Close Client Session
			objClientSession.close();
			break;
		}
		case ABORT :
		{
			System.out.println("Abort has arrived Stop Porcessing -- Association is no longer available");
		}
		}
	}

	/**
	 * This method notifies when a service related request is received.
	 * @param objClientSession  object of client session.
	 */
	public void onServiceRequest(ClientSession objClientSession)
	{
		/*
		 * Create CFindSCP get RQ from ClientSession call processRequest and pass CFindRequest on CFIND_SCP
		 * receive response from CFind_SCP sendResponse using ClientSession
		 */
		DIMSEResponse objDResponse = null;
		CFindSCP objCFindSCP = CFindSCP.createInstance(objClientSession); 
		try
		{
			System.out.println("SubstanceAdministrationInfoQry  :: C-Find Request Received");
			/*
			 * Process CFind Request.
			 * Set DatasourceImpl for SubstanceAdministrationInfoQry in C-Find SCP.
			 */
			objCFindSCP.setDataSourceList(getDataSourceList());
			objDResponse = objCFindSCP.processRequest(objClientSession.getDicomMessage());

			/*
			 * Send the service message through Client Session.
			 */
			if(objDResponse != null)
				objClientSession.sendServiceMessage(objDResponse);
			System.out.println("SubstanceAdministrationInfoQry  :: C-Find Response Sent");
		}catch(Exception ioe)
		{
			ioe.printStackTrace();
		}
	}

	/**
	 * Closes the Client Session,
	 */
	public void onClose(ClientSession objClientSession)
	{
		objClientSession.close();
	}
}
